clang 10.0.0git

Classes | Public Types | Public Member Functions | Friends | List of all members
clang::TemplateArgumentLocContainerIterator< ArgLocContainer > Class Template Reference

Simple iterator that traverses the template arguments in a container that provides a `getArgLoc()` member function. More...

`#include "/work/www-prereleases/10.0.0/rc1/docsbuild/clang/lib/Sema/TreeTransform.h"`

## Classes
class | pointer

## Public Types
typedef TemplateArgumentLoc | value_type
typedef TemplateArgumentLoc | reference
typedef int | difference_type
typedef std::input_iterator_tag | iterator_category

## Public Member Functions
| TemplateArgumentLocContainerIterator ()
| TemplateArgumentLocContainerIterator (ArgLocContainer &Container, unsigned Index)
TemplateArgumentLocContainerIterator & | operator++ ()
TemplateArgumentLocContainerIterator | operator++ (int)
TemplateArgumentLoc | operator* () const
pointer | operator-> () const

## Friends
bool | operator== (const TemplateArgumentLocContainerIterator &X, const TemplateArgumentLocContainerIterator &Y)
bool | operator!= (const TemplateArgumentLocContainerIterator &X, const TemplateArgumentLocContainerIterator &Y)

## Detailed Description

### template<typename ArgLocContainer>
class clang::TemplateArgumentLocContainerIterator< ArgLocContainer >

Simple iterator that traverses the template arguments in a container that provides a `getArgLoc()` member function.

This iterator is intended to be used with the iterator form of `TreeTransform<Derived>::TransformTemplateArguments()`.

Definition at line 6035 of file TreeTransform.h.

## Member Typedef Documentation

## ◆ difference_type

template<typename ArgLocContainer >

typedef int clang::TemplateArgumentLocContainerIterator< ArgLocContainer >::difference_type

Definition at line 6042 of file TreeTransform.h.

## ◆ iterator_category

template<typename ArgLocContainer >

typedef std::input_iterator_tag clang::TemplateArgumentLocContainerIterator< ArgLocContainer >::iterator_category

Definition at line 6043 of file TreeTransform.h.

## ◆ reference

template<typename ArgLocContainer >

typedef TemplateArgumentLoc clang::TemplateArgumentLocContainerIterator< ArgLocContainer >::reference

Definition at line 6041 of file TreeTransform.h.

## ◆ value_type

template<typename ArgLocContainer >

typedef TemplateArgumentLoc clang::TemplateArgumentLocContainerIterator< ArgLocContainer >::value_type

Definition at line 6040 of file TreeTransform.h.

## Constructor & Destructor Documentation

## ◆ TemplateArgumentLocContainerIterator() [1/2]

template<typename ArgLocContainer >

clang::TemplateArgumentLocContainerIterator< ArgLocContainer >::TemplateArgumentLocContainerIterator | ( |  | ) |
| inline

Definition at line 6057 of file TreeTransform.h.

## ◆ TemplateArgumentLocContainerIterator() [2/2]

template<typename ArgLocContainer >

clang::TemplateArgumentLocContainerIterator< ArgLocContainer >::TemplateArgumentLocContainerIterator | ( | ArgLocContainer & | Container,
|  | unsigned | Index
| ) |  |
| inline

Definition at line 6059 of file TreeTransform.h.

## Member Function Documentation

## ◆ operator*()

template<typename ArgLocContainer >

TemplateArgumentLoc clang::TemplateArgumentLocContainerIterator< ArgLocContainer >::operator* | ( |  | ) | const
| inline

Definition at line 6074 of file TreeTransform.h.

## ◆ operator++() [1/2]

template<typename ArgLocContainer >

TemplateArgumentLocContainerIterator& clang::TemplateArgumentLocContainerIterator< ArgLocContainer >::operator++ | ( |  | ) |
| inline

Definition at line 6063 of file TreeTransform.h.

## ◆ operator++() [2/2]

template<typename ArgLocContainer >

TemplateArgumentLocContainerIterator clang::TemplateArgumentLocContainerIterator< ArgLocContainer >::operator++ | ( | int |  | ) |
| inline

Definition at line 6068 of file TreeTransform.h.

## ◆ operator->()

template<typename ArgLocContainer >

pointer clang::TemplateArgumentLocContainerIterator< ArgLocContainer >::operator-> | ( |  | ) | const
| inline

Definition at line 6078 of file TreeTransform.h.

## Friends And Related Function Documentation

## ◆ operator!=

template<typename ArgLocContainer >

bool operator!= | ( | const TemplateArgumentLocContainerIterator< ArgLocContainer > & | X,
|  | const TemplateArgumentLocContainerIterator< ArgLocContainer > & | Y
| ) |  |
| friend

Definition at line 6087 of file TreeTransform.h.

## ◆ operator==

template<typename ArgLocContainer >

bool operator== | ( | const TemplateArgumentLocContainerIterator< ArgLocContainer > & | X,
|  | const TemplateArgumentLocContainerIterator< ArgLocContainer > & | Y
| ) |  |
| friend

Definition at line 6082 of file TreeTransform.h.

The documentation for this class was generated from the following file:

- lib/Sema/TreeTransform.h